## openmprtl 3.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
add_subdirectory(runtime)
