=== debian/changelog ===
openmprtl (3.7.0-3) unstable; urgency=medium

  * Fix the support of mips/mipsel.
    Thanks to Dejan Latinovic (Closes: #790735)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 21 Oct 2015 15:56:50 +0200

openmprtl (3.7.0-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Set SONAME to libiomp.so.5 properly (Closes: #775257)
  * Ship a libiomp5.so compat symlink.
  * Convert to multiarch.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Oct 2015 13:57:07 +0200

openmprtl (3.7.0-1) unstable; urgency=medium

  * New upstream release
  * Move to the LLVM version of the library (Closes: ##792180)
  * Rename the packages: s/iomp/omp/g
  * Fix the Vcs-* fields (Closes: #792179)
  * Update of the copyright file
  * Support of MIPS (Closes: #790735)
    Thanks to Dejan Latinovic for the patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 15 Sep 2015 15:58:03 +0200
